#define detect 3        //детектор нуля
#define triac 5        //тиристор
int napr = 1;  //номер аналогового порта трансформатора напряжения

String Var;
String T1, T2;

volatile unsigned int Mode = 0;  // Режим работы: 0 - регулятор, 1 - настройка, 2 - ??
volatile unsigned int ZCcntr = 0; // счетчик прерываний детектора нуля

volatile unsigned long Uism = 0; //мгновенные напряжения
volatile int cntr = 0; // счетчик в обработчике прерывания
volatile unsigned long Usumm = 0; // переменная для хранения суммы квадратов

int real_U = 0; //переменная расчета RMS напряжения
float sqrtUsum = 0.0; //переменная расчете квадратного корня
unsigned long previousMillis = 0;
unsigned long previousMillis_info = 0;

int ust_U = 0;
int angle_U = 2250;
int angle_U_ocr = 2250;
int t = 0;
volatile int zero = 0;

//=======================================================================================

void setup(void) {

  Serial.begin(9600);//активируем прием сообщения

  pinMode(detect, INPUT);     //детектор нуля
  pinMode(triac, OUTPUT);      //тиристор
  pinMode(napr, INPUT);     //трансформатор напряжения

  //===========================================================Настройка АЦП

  ADMUX = (0 << REFS1) | (1 << REFS0) | (0 << MUX2) | (0 << MUX1) | (1 << MUX0); //

  //--------------------------Включение АЦП

  ADCSRA = B11101111;

  //------ Timer1 ---------- Таймер задержки времени открытия триака после детектирования нуля (0 триак не откроется)

  TCCR1A = 0x00;  //
  TCCR1B = 0x00;    //
  TCCR1B = (1 << ICNC1) | (0 << CS12) | (1 << CS11) | (1 << CS10); // Тактирование от CLK.
  OCR1A = 2250;           // Верхняя граница счета. Диапазон от 0 до 65535.
  TIMSK1 = 0x00;

  attachInterrupt(1, zero_crosss_int, RISING);//вызов прерывания при детектировании нуля

}
//======================================================== Прерывание по нулю
void zero_crosss_int() {
  // PORTD &=  ~(1 << PORTD5);
  TCNT1 = 0;
  OCR1A = angle_U_ocr;
  zero++;
  ZCcntr++;
}

//======================================================== Обработка таймера по совпадению нуля
ISR (TIMER1_COMPA_vect)
{
  if (Mode == 0)
  {
    PORTD |=  (1 << PORTD5);
    TCNT1 = 65535 - 200;  //Импульс включения симистора 65536 -  1 - 4 мкс, 2 - 8 мкс, 3 - 12 мкс и тд
  }
}

ISR (TIMER1_OVF_vect) { //timer1 overflow
  if (Mode == 0)
  {
    PORTD &=  ~(1 << PORTD5);
    TCNT1 = OCR1A + 1;
  }
}
//======================================================== Обработка прерывания АЦП для расчета среднеквадратичного напр
ISR(ADC_vect)
{
  byte An_pin = ADCL;
  byte An = ADCH;
  Uism = (An << 8) + An_pin;
  Uism *= Uism;// возводим значение в квадрат
  Usumm += Uism; // складываем квадраты измерений
  cntr++;
}


void parseParams(String inputString) { //Функция разбора принятой в Serial port строки
  String bb = inputString;
  if (bb.substring(0, 2) == "TW")
  {
    T1 = bb.substring(bb.indexOf("TW", 2) + 3); //команда
    ust_U = T1.toInt(); //Выставленное напряжение с Serial порта
    Mode = 0;
  }
  else if (bb.substring(0, 2) == "M1")
  {
    Mode = 1;
    ust_U = 400;
  }
  else if (bb.substring(0, 2) == "M2")
  {
    Mode = 2;
  }
}

void loop(void) {

  while (Serial.available()) { //Serial port, пока не конец сообщения, читаем данные и формируем строку
    char ch = Serial.read();
    Var += ch;
    if (ch == '\n') {
      parseParams(Var); //вызываем функцию разбора принятой строки
      Var = "";
    }

  }

  if (zero >= 3) {//расчет среднеквадратичного//zero - количество полупериодов дря рассчета среднеквадратичного
    sqrtUsum = Usumm / cntr; //
    real_U = sqrt(sqrtUsum); //
    cntr = 0;
    Usumm = 0;// обнуляем суммы напряжений
    zero = 0;
  }

  //================================================================

  if (ust_U == 0) {
    TIMSK1 = 0x00;
    PORTD &=  ~(1 << PORTD5);
    angle_U = 2250;
  }
  else {
    TIMSK1 |= (1 << OCIE1A) | (1 << TOIE1);
  }

  if (ust_U < 35 && ust_U != 0) { //Если меньше 35, то 35
    ust_U = 35;
  }

  if (ust_U > 400 ) { //
    ust_U = 400; //
  }

  //=====================================Стабилизатор напряжения
  if (millis() - previousMillis >= 15) {
    previousMillis = millis();

    if (real_U > ust_U + 1) {
      angle_U++;
    }
    if (real_U < ust_U - 1) {
      angle_U--;
    }
    if (real_U < ust_U + 1 && real_U > ust_U - 1) {
      angle_U = angle_U;
    }

    if (angle_U > 2250) {
      angle_U = 2250;
    }
    if (angle_U <= 1) {
      angle_U = 1;
    }
  }

  //------------------------------------

  angle_U_ocr = angle_U;

  //=========================Информация в порт раз в секунду

  if (millis() - previousMillis_info >= 1000) {
    previousMillis_info = millis();

    Serial.print("Mode "); //покажем текущий режим
    Serial.println(Mode);

    if (Mode == 1)
    {
      digitalWrite(triac, HIGH);
      Serial.println("Rejim nastroiki");
      Serial.print("ZeroCross "); //сколько раз "сработал" детектор нуля
      Serial.println(ZCcntr);
      ZCcntr = 0;
    }

    Serial.print("realU "); //Измеренное среднеквадратичное напряжение
    Serial.println(real_U);

    Serial.print("ustU  "); //Установленное выходное напряжение
    Serial.println(ust_U);

    if (Mode == 0)
    {
      Serial.print("angleU ");
      Serial.println(angle_U);
    }

    Serial.println("---------------- -");
    //buffer_ust_U = buffer_ust_U + 1;
  }
  //=========================================================

}
